   MAX CssMin
   ----------

  I. Introduction
 II. Licence
III. Utilisation en ligne de commande
 IV. Utilisation en classe PHP
  V. Divers


I. Introduction
   ------------

MAX CssMin est un outils pour minifier vos fichiers CSS.
Il est écrit en PHP.

Minifier un fichier, c'est réduire sa taille, sans changer les 
fonctionnalités qu'il décrit. C'est comme une compression sans 
perte en quelque sorte.

Le but de la minification, c'est de réduire le plus possible la 
taille d'un fichier afin qu'il puisse être transférer le plus 
rapidement possible par les réseaux. En l'occurence, dans le cas 
des fichiers CSS, c'est pour accélérer le temps de chargement 
d'une page Web.

Par exemple pour quoi faire transférer :
p {
	margin: 5px 0px 5px 0px;
	padding: 2px 2px 2px 2px;
	color: #990000;
}

Quand cela suffit :
p{margin:5px 0;padding:2px;color:#900}

On passe de 75 octets à 38 octets, soit un ratio de 64 %. Cela
signifie que la version minifiée ne fait que 64 % de la taille 
de la version d'origine.

En général, une source minifiée n'est plus tellement lisible par un 
humain, même si dans le cas du CSS cela reste tout à fait possible. 
On préférera garder une source claire, écrite selon ses habitudes 
pour le développement et minifier la version en production sur les 
serveurs.

MAX CssMin se compose d'une classe PHP qui peut être incluse dans 
d'autres projets et d'un script, utilisant cette classe, afin de 
pouvoir être utilisable en ligne de commande.

MAX CssMin requiert PHP 5 pour fonctionner. Il a été testé 
sur les versions 5.2.6 , 5.2.10 et 5.3.2 avec succès.
Pour fonctionner en ligne de commande, il requiert PHP-CLI.


II. Licence
    -------

Copyright (C) 2010 Maxime Garcia.
All rights reserved.

MAX CssMin is free software: you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation, either version 3 of the License, or 
(at your option) any later version.

MAX CssMin is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
GNU General Public License for more details.

You should have received a copy of the GNU General Public License 
along with MAX CssMin.  If not, see <http://www.gnu.org/licenses/>.

Voir le fichier COPYING pour une version intégrale de la licence en 
anglais.

Une traduction française, non officielle, est disponoble sur dans le 
fichier COPYING.FR ou en ligne sur :
http://org.rodage.com/gpl-3.0.fr.html


III. Utilisation en ligne de commande
     --------------------------------

*** Prérequis ***

Rendre le fichier cssmin exécutable.
Sous Linux, on peut taper dans une console :
chmod +x cssmin

Sous Linux, on peut placer le fichier cssmin dans le dossier :
/home/nom_de_votre_user/bin
qui est dans le PATH ("echo $PATH" en console pour le constater)
afin d'être appelable de partout.

Sous Windows, éditer le fichier cssmin, et remplacer la première
ligne :
#!/usr/bin/php
par le chemin vers votre exécutable PHP, par exemple :
#!c:\php5\php.exe

*** Liste des options ***

Pour les obtenir une aide et la liste des options disponibles,
faites :
cssmin -h

*** Exemples simples ***

Pour minifier le fichier style.css, rendez vous dans son dossier,
en console et faites :
cssmin style.css style-min.css
Cela créera le fichier style-min.css qui sera minifié.

Pour minifier dans le même fichier, faites :
cssmin -r style.css
Cela remplacera style.css par sa version minifiée.

*** Utilisation avancée ***

MAX CssMin est compatible avec les pipes. Cela signifie qu'il
peut lire sur l'entrée standard et écrire sur la sortie standard.

Pour minifier le fichier style.css et écrire sur la sortie standard,
faites :
cssmin style.css

Pour rediriger cette sortie standard vers un fichier, par exemple 
style-min.css, en l'écrasant s'il existe, faites :
cssmin style.css > style-min.css

Un exemple. Admettons que vous ayez les fichiers suivants :
a.css
b.css
c.css
Vous pouvez les concaténer en un seul fichier all.css minifié en 
faisant :
cat a.css b.css c.css | cssmin > all.css

Ou bien :
cat *.css | cssmin > all.css


IV. Utilisation en classe PHP
    -------------------------

Il faut inclure le fichier MAX_CssMin.class.php contenant la classe
 MAX_CssMin
et appeler la fonction statique MAX_CssMin::run().

Exemple :
<?php

require "MAX_CssMin.class.php";

// Admettons que $mon_css contienne le code CSS à minifier
$mon_css = "  ... mon code CSS ...  ";

$css_min = MAX_CssMin::run($mon_css);

// $css_min contient alors la version minifiée

?>

Vous pouvez consulter le fichier cssmin.php dans le répertoire 
exemples de l'archive pour un exemple à peine plus poussé.


V. Divers
   ------

Vous utilisez MAX CssMin sur vos sites ou dans vos projets ?
Faites le nous savoir, on veut être fier des optimisations ainsi 
réalisée.

La site de MAX CssMin :
http://libre.maxbusiness.fr/cssmin/

Contacter l'auteur :
Par email : maxime.garcia@free.fr

Tous les autres Projets Libres par MAX Business sont sur :
http://libre.maxbusiness.fr

Si vous souhaitez aider et participer au développement de MAX CssMin,
n'hésitez pas à nous contacter. Toute aide est la bienvenue.


